Package: gcTensor
Type: Package
Title: Generalized Coupled Tensor Factorization
Version: 1.0.0
Authors@R: c(person("Koki", "Tsuyuzaki", role = c("aut", "cre"),
                      email = "k.t.the-answer@hotmail.co.jp"))
Suggests: testthat
Depends: R (>= 4.1.0)
Imports: rTensor, einsum
Description: Multiple matrices/tensors can be specified and decomposed simultaneously by Probabilistic Latent Tensor Factorisation (PLTF). See the reference section of GitHub README.md <https://github.com/rikenbit/gcTensor>, for details of the method.
License: MIT + file LICENSE
URL: https://github.com/rikenbit/gcTensor
Author: Koki Tsuyuzaki [aut, cre]
Maintainer: Koki Tsuyuzaki <k.t.the-answer@hotmail.co.jp>
Built: R 4.4.0; ; 2024-05-06 03:29:59 UTC; unix

#
# Test Estimates
#
# Test E-1: CP/MF/MF
# generate initial Z
# .initZ <- .genLatentVals(X_test, R_CP, Ranks_test)
.initZ <- gcTensor:::.genLatentVals(X_test, R_CP, Ranks_test)

# normalize initial Z
# visibleIdxs <- .visibleIdxs(X_test)
# latentIdxs <- .latentIdxs(Ranks_test, .initZ, visibleIdxs)
# normalizedInitZ <- .normalizeFactors(.initZ, R_CP, latentIdxs)$normalizedFactors
visibleIdxs <- gcTensor:::.visibleIdxs(X_test)
latentIdxs <- gcTensor:::.latentIdxs(Ranks_test, .initZ, visibleIdxs)
normalizedInitZ <- gcTensor:::.normalizeFactors(.initZ, R_CP, latentIdxs)$normalizedFactors

# estimate Z
resultGCTF <- GCTF(
    X_test, R_CP, M=NULL, initZ=.initZ, fix=NULL,
    Ranks_test, Beta=1, num.iter=1000, thr=1E-10, verbose=TRUE)

# normalize estimated Z
# normalizedEstimatedZ <- .normalizeFactors(resultGCTF$Z, R_CP, latentIdxs)$normalizedFactors
normalizedEstimatedZ <- gcTensor:::.normalizeFactors(resultGCTF$Z, R_CP, latentIdxs)$normalizedFactors

for (factorName in c("A", "B", "C", "D", "E")) {
    # plot answer
    plot(1:10,
        (Z_true[[factorName]] / sqrt(colSums(Z_true[[factorName]]^2)))[1:10, 1],
        type="b", col='black', pch="+", main=factorName, xlab="", ylab="")
    # rotate initial Z
    rotation <- SolveOrthgonalProcrustes(Z_true[[factorName]],
        normalizedInitZ[[factorName]])
    rotatedEstimates <- RotateEstimates(normalizedInitZ[[factorName]], rotation)
    # plot initial Z
    lines(1:10, rotatedEstimates[1:10, 1], type="b", col='blue', pch="*")
    # rotate estimated Z
    rotation <- SolveOrthgonalProcrustes(Z_true[[factorName]], normalizedEstimatedZ[[factorName]])
    rotatedEstimates <- RotateEstimates(normalizedEstimatedZ[[factorName]], rotation)
    # plot estimated Z
    lines(1:10, rotatedEstimates[1:10, 1], type="b", col='red', pch="o")
    if (factorName == 'A') {
        legend("topleft",
               legend = c("Original", "Initial", "Final"),
               col = c("black", "blue", "red"),
               pch = c("+", "*", "o"))
    }
}

# Visualize estimated factors (not normalized)
# to check if underflow or overflow happens.
for (factorName in c("A", "B", "C", "D", "E")) {
    ts.plot(resultGCTF$Z[[factorName]], main=factorName, xlab="row", ylab="", col=1:ncol(resultGCTF$Z[[factorName]]))
    legend("topright", legend=paste("column", 1:ncol(resultGCTF$Z[[factorName]])), col=1:ncol(resultGCTF$Z[[factorName]]), lty=1, cex=1)
}

library("gcTensor")
library("rTensor")
library("einsum")
library("testthat")

options(testthat.use_colours = FALSE)

source("testthat/setting.R")
test_file("testthat/test_InputObjectType.R")
test_file("testthat/test_OutputObjectType.R")
test_file("testthat/test_NonNegative.R")
test_file("testthat/test_Consistency.R")
test_file("testthat/test_DecreaseError.R")
# test_file("testthat/test_Estimates.R") # comment out (Heavy)
test_file("testthat/test_FixZ.R")

#
# Test Consistency of Objects
#

# Test C-1: X and Z
# CP
## I
expect_all_identical(
    dim(X$X1)[1],
    dim(X$X2)[1],
    dim(out.CP_EUC$Z$A)[1],
    dim(out.CP_KL$Z$A)[1],
    dim(out.CP_IS$Z$A)[1])
## J
expect_all_identical(
    dim(X$X1)[2],
    dim(X$X3)[1],
    dim(out.CP_EUC$Z$B)[1],
    dim(out.CP_KL$Z$B)[1],
    dim(out.CP_IS$Z$B)[1])
## K
expect_all_identical(
    dim(X$X1)[3],
    dim(out.CP_EUC$Z$C)[1],
    dim(out.CP_KL$Z$C)[1],
    dim(out.CP_IS$Z$C)[1])
## M
expect_all_identical(
    dim(X$X2)[2],
    dim(out.CP_EUC$Z$D)[1],
    dim(out.CP_KL$Z$D)[1],
    dim(out.CP_IS$Z$D)[1])
## N
expect_all_identical(
    dim(X$X3)[2],
    dim(out.CP_EUC$Z$E)[1],
    dim(out.CP_KL$Z$E)[1],
    dim(out.CP_IS$Z$E)[1])

# Tucker
## I
expect_all_identical(
    dim(X$X1)[1],
    dim(X$X2)[1],
    dim(out.Tucker_EUC$Z$A)[1],
    dim(out.Tucker_KL$Z$A)[1],
    dim(out.Tucker_IS$Z$A)[1])
## J
expect_all_identical(
    dim(X$X1)[2],
    dim(X$X3)[1],
    dim(out.Tucker_EUC$Z$B)[1],
    dim(out.Tucker_KL$Z$B)[1],
    dim(out.Tucker_IS$Z$B)[1])
## K
expect_all_identical(
    dim(X$X1)[3],
    dim(out.Tucker_EUC$Z$C)[1],
    dim(out.Tucker_KL$Z$C)[1],
    dim(out.Tucker_IS$Z$C)[1])
## M
expect_all_identical(
    dim(X$X2)[2],
    dim(out.Tucker_EUC$Z$E)[1],
    dim(out.Tucker_KL$Z$E)[1],
    dim(out.Tucker_IS$Z$E)[1])
## N
expect_all_identical(
    dim(X$X3)[2],
    dim(out.Tucker_EUC$Z$F)[1],
    dim(out.Tucker_KL$Z$F)[1],
    dim(out.Tucker_IS$Z$F)[1])

# Test C-2: X and M
# Expect no error when partially masked some rows
M <- X
M$X1 <- M$X1 * 0 + 1
# Mask only rows 1:3
M$X2 <- M$X2 * 1
M$X2[1:3, 1:7] <- 0
M$X3 <- M$X3 * 0 + 1
expect_error(
    GCTF(X=X, R=R_CP, M=M, Ranks=Ranks_CP, Beta=0),
    regexp=NA)  # regexp=NA means "there should be no errors"

# Expect error when completely masked some columns
M <- X
M$X1 <- M$X1 * 0 + 1
# Mask some column
M$X2 <- M$X2 * 1
M$X2[1:4, 7] <- 0
M$X3 <- M$X3 * 0 + 1
expect_error(GCTF(X=X, R=R_CP, M=M, Ranks=Ranks_CP, Beta=0))

# Expect error when completely masked
M <- X
M$X1 <- M$X1 * 0 + 1
# Mask all rows (1:4)
M$X2 <- M$X2 * 1
M$X2[1:4, 1:7] <- 0
M$X3 <- M$X3 * 0 + 1
expect_error(GCTF(X=X, R=R_CP, M=M, Ranks=Ranks_CP, Beta=0))

# Test C-3: Rank and Z
# CP
## A
expect_all_equal(
    unlist(Ranks_CP$A),
    dim(out.CP_EUC$Z$A),
    dim(out.CP_KL$Z$A),
    dim(out.CP_IS$Z$A))
## B
expect_all_equal(
    unlist(Ranks_CP$B),
    dim(out.CP_EUC$Z$B),
    dim(out.CP_KL$Z$B),
    dim(out.CP_IS$Z$B))
## C
expect_all_equal(
    unlist(Ranks_CP$C),
    dim(out.CP_EUC$Z$C),
    dim(out.CP_KL$Z$C),
    dim(out.CP_IS$Z$C))
## D
expect_all_equal(
    unlist(Ranks_CP$D),
    dim(out.CP_EUC$Z$D),
    dim(out.CP_KL$Z$D),
    dim(out.CP_IS$Z$D))
## E
expect_all_equal(
    unlist(Ranks_CP$E),
    dim(out.CP_EUC$Z$E),
    dim(out.CP_KL$Z$E),
    dim(out.CP_IS$Z$E))

# Tucker
## A
expect_all_equal(
    unlist(Ranks_Tucker$A),
    dim(out.Tucker_EUC$Z$A),
    dim(out.Tucker_KL$Z$A),
    dim(out.Tucker_IS$Z$A))
## B
expect_all_equal(
    unlist(Ranks_Tucker$B),
    dim(out.Tucker_EUC$Z$B),
    dim(out.Tucker_KL$Z$B),
    dim(out.Tucker_IS$Z$B))
## C
expect_all_equal(
    unlist(Ranks_Tucker$C),
    dim(out.Tucker_EUC$Z$C),
    dim(out.Tucker_KL$Z$C),
    dim(out.Tucker_IS$Z$C))
## E
expect_all_equal(
    unlist(Ranks_Tucker$E),
    dim(out.Tucker_EUC$Z$E),
    dim(out.Tucker_KL$Z$E),
    dim(out.Tucker_IS$Z$E))
## F
expect_all_equal(
    unlist(Ranks_Tucker$F),
    dim(out.Tucker_EUC$Z$F),
    dim(out.Tucker_KL$Z$F),
    dim(out.Tucker_IS$Z$F))

# Test C-4: num.iter, RecError, and RelChange
# CP
expect_all_equal(
    formals(GCTF)$num.iter,
    length(out.CP_EUC$RecError)-1,
    length(out.CP_KL$RecError)-1,
    # length(out.CP_IS$RecError)-1,
    length(out.CP_EUC$RelChange)-1,
    length(out.CP_KL$RelChange)-1)
    # length(out.CP_IS$RelChange)-1)

# Tucker
expect_all_equal(
    formals(GCTF)$num.iter,
    length(out.Tucker_EUC$RecError)-1,
    length(out.Tucker_KL$RecError)-1,
    # length(out.Tucker_IS$RecError)-1,
    length(out.Tucker_EUC$RelChange)-1,
    length(out.Tucker_KL$RelChange)-1)
    # length(out.Tucker_IS$RelChange)-1)

#
# Test Fixation of Z
#

# Test Z-1
fixAlphas <- c(TRUE, FALSE, TRUE, FALSE, FALSE)

resultGCTF <- GCTF(X=X_test, R=R_CP, Ranks=Ranks_test, Beta=1, num.iter=1)
fixedA <- resultGCTF$Z$A
fixedC <- resultGCTF$Z$C
initial_Z <- resultGCTF$Z
initial_Z$A <- initial_Z$A * 0 + 0.1
initial_Z$C <- initial_Z$C * 0 + 0.2
resultGCTF <- GCTF(X=X_test, R=R_CP, initZ=initial_Z, fix=fixAlphas, Ranks=Ranks_test, Beta=1, num.iter=10)

expect_true(all(resultGCTF$Z$A == initial_Z$A))
expect_true(all(resultGCTF$Z$B != initial_Z$B))
expect_true(all(resultGCTF$Z$C == initial_Z$C))
expect_true(all(resultGCTF$Z$D != initial_Z$D))
expect_true(all(resultGCTF$Z$E != initial_Z$E))

#
# Test Input object / type
#

# Test I-1: Object Names
expect_identical(names(formals(GCTF)),
    c("X", "R", "M", "pseudocount", "initZ", "fix", "Ranks", "Beta", "num.iter", "thr", "verbose"))

# Test I-2: X
expect_identical(as.character(formals(GCTF)$X), "")

# Test I-3: R
expect_identical(as.character(formals(GCTF)$R), "")

# Test I-4: M
expect_identical(formals(GCTF)$M, NULL)

# Test
expect_identical(eval(formals(GCTF)$pseudocount), .Machine$double.eps)

# Test I-5: initZ
expect_identical(formals(GCTF)$initZ, NULL)

# Test I-6: fix
expect_identical(formals(GCTF)$fix, NULL)

# Test I-7: Ranks
expect_identical(as.character(formals(GCTF)$Ranks), "")

# Test I-8: Beta
expect_identical(formals(GCTF)$Beta, 1)

# Test I-9: num.iter
expect_identical(formals(GCTF)$num.iter, 30)

# Test I-10: thr
expect_identical(formals(GCTF)$thr, 1E-10)

# Test I-11: verbose
expect_identical(formals(GCTF)$verbose, FALSE)

#
# Test Monotonous Decrease of Error
#

# Test M-1: RecError
# CP
expect_identical(order(out.CP_EUC$RecError[2:31]), rev(seq(30)))
expect_identical(order(out.CP_KL$RecError[2:31]), rev(seq(30)))

# Not run: In IS case, computation may be unsteady.
# expect_identical(order(out.CP_IS$RecError[2:31]), rev(seq(30)))

# Tucker
expect_identical(order(out.Tucker_EUC$RecError[2:31]), rev(seq(30)))
expect_identical(order(out.Tucker_KL$RecError[2:31]), rev(seq(30)))

# Not run: In IS case, computation may be unsteady.
# expect_identical(order(out.Tucker_IS$RecError[2:31]), rev(seq(30)))

# Test M-2: RelChange
# first element of RelChange doesn't have to be sequentially ordered.

# CP
expect_identical(order(selectThreePoints(out.CP_EUC$RelChange[2:31])), 3:1)
expect_identical(order(selectThreePoints(out.CP_KL$RelChange[2:31])), 3:1)
# expect_identical(order(selectThreePoints(out.CP_IS$RelChange[2:31])), 3:1)

# Tucker
expect_identical(order(selectThreePoints(out.Tucker_EUC$RelChange[2:31])), 3:1)
expect_identical(order(selectThreePoints(out.Tucker_KL$RelChange[2:31])), 3:1)
# expect_identical(order(selectThreePoints(out.Tucker_IS$RelChange[2:31])), 3:1)

# # Check RecError and RelChange of Tucker EUC
# plot(out.Tucker_EUC$RecError)
# plot(out.Tucker_EUC$RelChange, log="y")

#
# For testthat/test_Consistency.R
#

# define `expect_all_*()` because `expect_*()` cannot check if multiple
# values are all the same.
expect_all_identical <- function(object, ...) {
    expects <- list(...)
    for (expect in expects) {
        expect_identical(object, expect)
    }
}
expect_all_equal <- function(object, ...) {
    expects <- list(...)
    for (expect in expects) {
        expect_equal(object, expect)
    }
}
expect_all_equivalent <- function(object, ...) {
    expects <- list(...)
    for (expect in expects) {
        expect_equivalent(object, expect)
    }
}

#
# For All
#

# Simulation Datasets
set.seed(123)

# I × J × K
X1 <- rand_tensor(modes = c(4, 5, 6))
X1 <- X1@data^2
names(dim(X1)) <- c("I", "J", "K")

# I × P
X2 <- matrix(runif(4 * 7), nrow=4, ncol=7)
names(dim(X2)) <- c("I", "M")

# J × Q
X3 <- matrix(runif(5 * 8), nrow=5, ncol=8)
names(dim(X3)) <- c("J", "N")

# Coupled Tensor/Matrix
X <- list(X1 = X1, X2 = X2, X3 = X3)

# Coupling matrix R（CP）
R_CP <- rbind(
    c(1,1,1,0,0),
    c(1,0,0,1,0),
    c(0,1,0,0,1)
)
rownames(R_CP) <- paste0("X", seq(3))
colnames(R_CP) <- LETTERS[seq(5)]

# Size of Factor matrices (CP)
Ranks_CP <- list(
    A=list(I=4, r=3),
    B=list(J=5, r=3),
    C=list(K=6, r=3),
    D=list(M=7, r=3),
    E=list(N=8, r=3))

# Coupling matrix R（Tucker）
R_Tucker <- rbind(
    c(1,1,1,1,0,0),
    c(1,0,0,0,1,0),
    c(0,1,0,0,0,1)
)
rownames(R_Tucker) <- paste0("X", seq(3))
colnames(R_Tucker) <- LETTERS[seq(6)]

# Size of Factor matrices (Tucker)
Ranks_Tucker <- list(
    A=list(I=4, p=3),
    B=list(J=5, q=4),
    C=list(K=6, r=3),
    D=list(p=3, q=4, r=3),
    E=list(M=7, p=3),
    F=list(N=8, q=4))

# CP
out.CP_EUC <- GCTF(X, R_CP, Ranks=Ranks_CP, Beta=0, verbose=FALSE)
out.CP_KL <- GCTF(X, R_CP, Ranks=Ranks_CP, Beta=1, verbose=FALSE)
out.CP_IS <- GCTF(X, R_CP, Ranks=Ranks_CP, Beta=2, verbose=FALSE)

# Tucker
out.Tucker_EUC <- GCTF(X, R_Tucker, Ranks=Ranks_Tucker, Beta=0, verbose=FALSE)
out.Tucker_KL <- GCTF(X, R_Tucker, Ranks=Ranks_Tucker, Beta=1, verbose=FALSE)
out.Tucker_IS <- GCTF(X, R_Tucker, Ranks=Ranks_Tucker, Beta=2, verbose=FALSE)

# CP
expect_identical(is.list(out.CP_EUC), TRUE)
expect_identical(is.list(out.CP_KL), TRUE)
expect_identical(is.list(out.CP_IS), TRUE)

# Tucker
expect_identical(is.list(out.Tucker_EUC), TRUE)
expect_identical(is.list(out.Tucker_KL), TRUE)
expect_identical(is.list(out.Tucker_IS), TRUE)

#
# For testthat/test_DecreaseError.R
#
selectThreePoints <- function(x){
    x1 <- x[1]
    x2 <- x[ceiling(median(seq_along(x)))]
    x3 <- rev(x)[1]
    c(x1, x2, x3)
}

#
# For testthat/test_{Estimates,FixZ}.R
#

# The test in Yilmaz and Umut (2011) is performed using the synthetic data.
# No mentions about the scale in the article.
# This implementation compares the true and estimated Zs after normalization.
set.seed(123)

I_test = 30
J_test = 30
K_test = 30
M_test = 30
N_test = 30
r_test = 5
A_test = matrix(runif(I_test*r_test), I_test, r_test); names(dim(A_test)) <- c("I", "r")
B_test = matrix(runif(J_test*r_test), J_test, r_test); names(dim(B_test)) <- c("J", "r")
C_test = matrix(runif(K_test*r_test), K_test, r_test); names(dim(C_test)) <- c("K", "r")
D_test = matrix(runif(M_test*r_test), M_test, r_test); names(dim(D_test)) <- c("M", "r")
E_test = matrix(runif(N_test*r_test), N_test, r_test); names(dim(E_test)) <- c("N", "r")
Z_true <- list(A=A_test, B=B_test, C=C_test, D=D_test, E=E_test)
X1_test <- array(rep(0, I_test*J_test*K_test), dim=c(I_test, J_test, K_test)); names(dim(X1_test)) <- c("I", "J", "K")
for (i in 1:I_test) {
    for (j in 1:J_test) {
        for (k in 1:K_test) {
            X1_test[i, j, k] <- sum(A_test[i, ] * B_test[j, ] * C_test[k, ])
        }
    }
}
X2_test <- array(rep(0, I_test*M_test), dim=c(I_test, M_test)); names(dim(X2_test)) <- c("I", "M")
for (i in 1:I_test) {
    for (m in 1:M_test) {
        X2_test[i, m] <- sum(A_test[i, ] * D_test[m, ])
    }
}
X3_test <- array(rep(0, J_test*N_test), dim=c(J_test, N_test)); names(dim(X3_test)) <- c("J", "N")
for (j in 1:J_test) {
    for (n in 1:N_test) {
        X3_test[j, n] <- sum(B_test[j, ] * E_test[n, ])
    }
}
X_test <- list(X1=X1_test, X2=X2_test, X3=X3_test)

# Visible Indices e.g. I, J, K, P, Q
# visibleIdxs_a <- .visibleIdxs(X_test)
visibleIdxs_a <- gcTensor:::.visibleIdxs(X_test)

# Latent Indices e.g. p, q, r
# latentIdxs_a <- .latentIdxs(Ranks_CP, Z_true, visibleIdxs_a)
latentIdxs_a <- gcTensor:::.latentIdxs(Ranks_CP, Z_true, visibleIdxs_a)

Ranks_test <- list(
    A=list(I=I_test, r=r_test),
    B=list(J=J_test, r=r_test),
    C=list(K=K_test, r=r_test),
    D=list(M=M_test, r=r_test),
    E=list(N=N_test, r=r_test))

#
# For testthat/test_Estimates.R
#
SolveOrthgonalProcrustes <- function(refrence, estimates) {
    # To find the correct permutation, for each of Z_alpha
    # the matching permutation between the original and estimate found
    # by solving an orthgonal Procrustes problem.
    svdResult <- svd(t(refrence) %*% estimates)
    rotation <- svdResult$u %*% t(svdResult$v)
    return(rotation)
}

RotateEstimates <- function(estimates, rotation) {
    return(estimates %*% t(rotation))
}

# These methods are used for Test E-1: CP/MF/MF
# GCTF doesn't use these methods.

.MulTensors <- function(tensorList) {
    dims <- unlist(lapply(tensorList, function(x){dim(x)}))
    dimnames <- sort(unique(names(dims)))
    dims <- dims[dimnames]
    tensorListExpand <- lapply(tensorList, function(x){
        this_dims <- dim(x)
        this_dimnames <- names(this_dims)
        missing_dimnames <- setdiff(dimnames, this_dimnames)
        missing_dims <- dims[missing_dimnames]
        new_x <- array(rep(x, prod(missing_dims)), c(this_dims, missing_dims))
        new_x <- aperm(new_x, order(names(dim(new_x))))

        return(new_x)
    })
    tensorsProd <- 1
    for (tensorExpand in tensorListExpand) {
        tensorsProd <- tensorsProd * tensorExpand
    }
    tensorsProd
}

# Normalization
# compute normalized Z and scaling tensors Lambdas
.normalizeFactors <- function(Z, R, latentIdxs) {

    # normalize all factors.
    # compute normalized factors and scaling tensors.

    # normalized factors:
    #   list. number of elements are same of Z.
    #   each elements are tensors.
    #   the shape of each elements are same of Zs.
    #
    # scaling tensors:
    #   list. number of eleme-nts are same of Z.
    #   each elements are tensors.
    #   the length of each elements are
    #   number of latent indice of each Zs elements.
    #   (for example, scaling tensor S1's shape is [p,q] if Z1 is shape[I,J,p,q])

    normalizedFactors <- list()
    scalingTensors <- list()

    # loop for each factors
    for (Alpha in seq_len(ncol(R))) {

        latentDimNamesOfZAlpha <- intersect(names(latentIdxs), names(dim(Z[[Alpha]])))
        latentIdxLocations <- which(names(dim(Z[[Alpha]])) %in% latentDimNamesOfZAlpha)
        latentDimNamesOfZAlpha <- names(dim(Z[[Alpha]]))[latentIdxLocations]

        if (length(latentDimNamesOfZAlpha) == 1) {
            scalingTensor <- as.array(apply(
                    Z[[Alpha]]^2,
                    which(names(dim(Z[[Alpha]])) %in% latentDimNamesOfZAlpha),
                sum)^(1/2))
            names(dim(scalingTensor)) <- latentDimNamesOfZAlpha
            normalizedFactor <- .MulTensors(list(Z[[Alpha]], 1 / scalingTensor))
        } else {
            scalingTensor <- sqrt(sum(Z[[Alpha]]^2))
            normalizedFactor <- Z[[Alpha]] / scalingTensor
        }

        normalizedFactors[[length(normalizedFactors) + 1]] <- normalizedFactor
        scalingTensors[[length(scalingTensors) + 1]] <- scalingTensor
    }
    # aggregate scaling tensors of factors into scaling tensors of observational tensors.

    # scaling tensors of observational tensors
    #  ... list. number of elements are same of X.
    #      each elements are tensors.
    #      the dimensions of each elements(=tensor) are
    #      all latent indeice of its related factors.

    observationalScalingTensors <- list()

    for (v in seq_len(nrow(R))) {
        scalingTensorsOfRelatedFactors <- list()
        for (Alpha in seq_len(ncol(R))) {
            if (R[v, Alpha] == 1) {
                scalingTensorsOfRelatedFactors[[length(scalingTensorsOfRelatedFactors) + 1]] <- scalingTensors[[Alpha]]
            }
        }
        observationalScalingTensors[[length(observationalScalingTensors) + 1]] <-
            .MulTensors(scalingTensorsOfRelatedFactors)
    }

    result <- list(
        normalizedFactors = normalizedFactors,
        observationalScalingTensors = observationalScalingTensors)

    names(result$normalizedFactors) <- names(Z)
    names(result$observationalScalingTensors) <- names(X)

    result
}

#
# Test Output object / type
#

# Test O-1: Object
# CP
expect_identical(is.list(out.CP_EUC), TRUE)
expect_identical(is.list(out.CP_KL), TRUE)
expect_identical(is.list(out.CP_IS), TRUE)

# Tucker
expect_identical(is.list(out.Tucker_EUC), TRUE)
expect_identical(is.list(out.Tucker_KL), TRUE)
expect_identical(is.list(out.Tucker_IS), TRUE)

# Test O-2: Object Names
objNames <- c("X", "Z", "R", "Ranks", "Beta", "num.iter",
	"thr", "RecError", "TrainRecError", "TestRecError", "RelChange")

# CP
expect_identical(names(out.CP_EUC), objNames)
expect_identical(names(out.CP_KL), objNames)
expect_identical(names(out.CP_IS), objNames)

# Tucker
expect_identical(names(out.Tucker_EUC), objNames)
expect_identical(names(out.Tucker_KL), objNames)
expect_identical(names(out.Tucker_IS), objNames)

# Test O-3: X
# CP
expect_identical(out.CP_EUC$X, X)
expect_identical(out.CP_KL$X, X)
expect_identical(out.CP_IS$X, X)

# Tucker
expect_identical(out.Tucker_EUC$X, X)
expect_identical(out.Tucker_KL$X, X)
expect_identical(out.Tucker_IS$X, X)

# Test O-4: Z
# CP
expect_identical(is.list(out.CP_EUC$Z), TRUE)
expect_identical(is.list(out.CP_KL$Z), TRUE)
expect_identical(is.list(out.CP_IS$Z), TRUE)

# Tucker
expect_identical(is.list(out.Tucker_EUC$Z), TRUE)
expect_identical(is.list(out.Tucker_KL$Z), TRUE)
expect_identical(is.list(out.Tucker_IS$Z), TRUE)

# Test O-5: R
# CP
expect_identical(out.CP_EUC$R, R_CP)
expect_identical(out.CP_KL$R, R_CP)
expect_identical(out.CP_IS$R, R_CP)

# Tucker
expect_identical(out.Tucker_EUC$R, R_Tucker)
expect_identical(out.Tucker_KL$R, R_Tucker)
expect_identical(out.Tucker_IS$R, R_Tucker)

# Test O-6: Rank
# CP
expect_identical(out.CP_EUC$Ranks, Ranks_CP)
expect_identical(out.CP_KL$Ranks, Ranks_CP)
expect_identical(out.CP_IS$Ranks, Ranks_CP)

# Tucker
expect_identical(out.Tucker_EUC$Ranks, Ranks_Tucker)
expect_identical(out.Tucker_KL$Ranks, Ranks_Tucker)
expect_identical(out.Tucker_IS$Ranks, Ranks_Tucker)

# Test O-7: Beta
# CP
expect_identical(out.CP_EUC$Beta, 0)
expect_identical(out.CP_KL$Beta, 1)
expect_identical(out.CP_IS$Beta, 2)

# Tucker
expect_identical(out.Tucker_EUC$Beta, 0)
expect_identical(out.Tucker_KL$Beta, 1)
expect_identical(out.Tucker_IS$Beta, 2)

# Test O-8: num.iter
# CP
expect_identical(out.CP_EUC$iter, formals(GCTF)$iter)
expect_identical(out.CP_KL$iter, formals(GCTF)$iter)
expect_identical(out.CP_IS$iter, formals(GCTF)$iter)

# Tucker
expect_identical(out.Tucker_EUC$iter, formals(GCTF)$iter)
expect_identical(out.Tucker_KL$iter, formals(GCTF)$iter)
expect_identical(out.Tucker_IS$iter, formals(GCTF)$iter)

# Test O-9: thr
# CP
expect_identical(out.CP_EUC$thr, formals(GCTF)$thr)
expect_identical(out.CP_KL$thr, formals(GCTF)$thr)
expect_identical(out.CP_IS$thr, formals(GCTF)$thr)

# Tucker
expect_identical(out.Tucker_EUC$thr, formals(GCTF)$thr)
expect_identical(out.Tucker_KL$thr, formals(GCTF)$thr)
expect_identical(out.Tucker_IS$thr, formals(GCTF)$thr)

# Test O-10: RecError
# CP
expect_identical(is.vector(out.CP_EUC$RecError), TRUE)
expect_identical(is.vector(out.CP_KL$RecError), TRUE)
expect_identical(is.vector(out.CP_IS$RecError), TRUE)

expect_identical(is.vector(out.CP_EUC$TrainRecError), TRUE)
expect_identical(is.vector(out.CP_KL$TrainRecError), TRUE)
expect_identical(is.vector(out.CP_IS$TrainRecError), TRUE)

expect_identical(is.vector(out.CP_EUC$TestRecError), TRUE)
expect_identical(is.vector(out.CP_KL$TestRecError), TRUE)
expect_identical(is.vector(out.CP_IS$TestRecError), TRUE)

# Tucker
expect_identical(is.vector(out.Tucker_EUC$RecError), TRUE)
expect_identical(is.vector(out.Tucker_KL$RecError), TRUE)
expect_identical(is.vector(out.Tucker_IS$RecError), TRUE)

expect_identical(is.vector(out.Tucker_EUC$TrainRecError), TRUE)
expect_identical(is.vector(out.Tucker_KL$TrainRecError), TRUE)
expect_identical(is.vector(out.Tucker_IS$TrainRecError), TRUE)

expect_identical(is.vector(out.Tucker_EUC$TestRecError), TRUE)
expect_identical(is.vector(out.Tucker_KL$TestRecError), TRUE)
expect_identical(is.vector(out.Tucker_IS$TestRecError), TRUE)

# Test O-11: RelChange
# CP
expect_identical(is.vector(out.CP_EUC$RelChange), TRUE)
expect_identical(is.vector(out.CP_KL$RelChange), TRUE)
expect_identical(is.vector(out.CP_IS$RelChange), TRUE)

# Tucker
expect_identical(is.vector(out.Tucker_EUC$RelChange), TRUE)
expect_identical(is.vector(out.Tucker_KL$RelChange), TRUE)
expect_identical(is.vector(out.Tucker_IS$RelChange), TRUE)
